#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <stdlib.h>

int iter = 0;

void header(void)
{
int i;
struct text_info ti;
gettextinfo(&ti);
clrscr();
textcolor(9);
cprintf("");
for(i = 0; i < ti.screenwidth-2; i++)
cprintf("");
cprintf("\r");
cprintf("");
gotoxy(25, 2);
textcolor(12);
cprintf("Ivan Derevyanko, IUST-12, Lab#4");
textcolor(9);
gotoxy(ti.screenwidth, 2);
cprintf("\r");
cprintf("");
for(i = 0; i < ti.screenwidth-2; i++)
cprintf("");
cprintf("");
}


typedef float (*tfunc)(float x);
typedef float (*sich)(tfunc func, float x_poch1, float x_poch0, float e_f);

float sichni(tfunc func, float x_poch1, float x_poch0, float e_f)
{
float x_next;
do
{
x_next = x_poch1 - (func(x_poch1)*(x_poch1 - x_poch0))/(func(x_poch1)-func(x_poch0));
x_poch0 = x_poch1;
x_poch1 = x_next;
iter++;
}while(fabs(func(x_next)) > e_f);
return x_next;
}

float func1(float x)
{
return x*x - 4;
}

float func2(float x)
{
return pow(x ,2) + 4*x + 3;
}

float func3(float x)
{
return sin(x);
}

void menu(char *ans)
{
header();
gotoxy(25, 5);
textcolor(14);
cprintf("1) x^2 - 4");
gotoxy(25, 6);
cprintf("2) x^2 + 4*x + 3");
gotoxy(25, 7);
cprintf("3) sin(x)");
gotoxy(25, 9);
textcolor(15);
cprintf("q) Exit");
gotoxy(25,10);
textcolor(12);
cprintf("Ansver: ");
scanf("%c", ans);
}

void input(float* x0, float* x1, float *e)
{
header();
textcolor(13);
gotoxy(25, 8);
cprintf("Input x0: ");
scanf("%f", x0);
gotoxy(25, 9);
cprintf("Input x1: ");
scanf("%f", x1);
gotoxy(25, 10);
cprintf("Input e: ");
scanf("%f", e);
}

//output(sich fun, char ans)
//{
//header();
//textcolor(11);
//gotoxy(20, 8);
//cprintf("Koren: %f", fun() )
//}

void exit_m(void)
{
gotoxy(25, 20);
textcolor(12);
cprintf("Press ESC to Exit");
if(getch() == 27)
exit(0);
}


void main(void)
{
textmode(C80);
float x1, x0, e;
char ans;
header();
while(1)
{
menu(&ans);
switch(ans)
{
case '1' :
{
	input(&x0, &x1, &e);
	header();
	textcolor(11);
	gotoxy(25, 8);
	cprintf("Korin X1 = %f", sichni(func1, x1, x0, e));
	gotoxy(25, 9);
	cprintf("Korin X2 = %f", -sichni(func1, x1, x0, e));
	gotoxy(25, 11);
	textcolor(10);
	cprintf("Itteration: %d", iter);
	gotoxy(25, 13);
	textcolor(13);
	cprintf("Znachennya function: %f", func1(sichni(func1, x1, x0, e)));
	exit_m();
	break;
}
case '2' :
{
	input(&x0, &x1, &e);
	header();
	textcolor(11);
	gotoxy(25, 8);
	cprintf("Korin X1 = %f", sichni(func2, x1, x0, e));
	x0 = -10;
	x1 = -9;
	gotoxy(25, 9);
	cprintf("Korin X2 = %f", sichni(func2, x1, x0, e));
	gotoxy(25, 10);
	textcolor(10);
	cprintf("Itteration: %d", iter);
	gotoxy(25, 12);
	textcolor(13);
	cprintf("Znachennya function: %f", func2(sichni(func2, x1, x0, e)));
	exit_m();
	break;
}
case '3' :
{
	input(&x0, &x1, &e);
	header();
	textcolor(11);
	gotoxy(25, 8);
	cprintf("Korini X = %f +/- Pi*n, n  Z", sichni(func3, x1, x0, e));
	gotoxy(25, 10);
	textcolor(10);
	cprintf("Itteration: %d", iter);
	gotoxy(25, 12);
	textcolor(13);
	cprintf("Znachennya function: %f", func3(sichni(func3, x1, x0, e)));

	exit_m();
	break;
}
case 'q' :
{
	exit(0);
	break;
}
default : {continue;}
}
}
//printf("%c", ans);
//printf("\nInput x0, x1, e: ");
//scanf("%f%f%f", &x0, &x1, &e);

//printf("\n Znachennya: %f", sichni(func1, x1, x0, e));
//printf("\n Iteratsiy: %d", iter);
getch();
}

